%{
(*Header*)
open Utilities;;

let parse_error s =
    print_endline  "Parse error";
    print_endline s;
    flush stdout;;

%}

/* token declarations*/

%token <string> STRING
%token <int> INT
%token TAB
%token TABS
%token EOF EOL
%type <Utilities.node list list> sentenceList
%start sentenceList

%%
sentenceList: 
  wl EOL sentenceList {(makeSentence (List.rev $1)) :: $3}
| wl EOL {[(makeSentence (List.rev $1))]}
| wl {[makeSentence (List.rev $1)]}
| EOF {[makeSentence []]}
;


wl:
/*word lemma cat parent */
|STRING TABS STRING TABS STRING TABS INT EOL wl {(makeNode $1 $3 $5 $7)::$9}
|STRING TABS STRING TABS STRING TABS INT EOL {[makeNode $1 $3 $5 $7]}
/*word lemma cat*/
|STRING TABS STRING TABS STRING EOL wl {(makeNode $1 $3 $5 (-2))::$7}
|STRING TABS STRING TABS STRING EOL {[makeNode $1 $3 $5 (-2)]}
/*word cat parent */
|STRING TABS STRING TABS INT EOL wl {(makeNode $1 "" $3 $5)::$7}
|STRING TABS STRING TABS INT EOL {[makeNode $1 "" $3 $5]}
|INT TABS STRING TABS INT EOL wl {(makeNode (string_of_int $1) "" $3 $5)::$7}
|INT TABS STRING TABS INT EOL {[makeNode (string_of_int $1) "" $3 $5]}

/*word cat */
|STRING TABS STRING EOL wl {(makeNode $1 "" $3 (-2))::$5}
|STRING TABS STRING EOL {[makeNode $1 "" $3 (-2)]}
|INT TABS STRING EOL wl {(makeNode (string_of_int $1) "" $3 (-2))::$5}
|INT TABS STRING EOL {[makeNode (string_of_int $1) "" $3 (-2)]}
;


%%









